// settings.js

/* ***** BEGIN LICENSE BLOCK *****
 * Licensed under Version: MPL 1.1/GPL 2.0/LGPL 2.1
 * Full Terms at http://mozile.mozdev.org/license.html
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Playsophy code.
 *
 * The Initial Developer of the Original Code is Playsophy
 * Portions created by the Initial Developer are Copyright (C) 2002-2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *		James A. Overton <james@overton.ca>
 *		Paul Everitt
 *
 * ***** END LICENSE BLOCK ***** */

/*******

Mozile Settings Javascript
Mozile version 0.61

Created by James A. Overton
Created on 2004-03-29

Last revised by James A. Overton
Last revised on 2004-04-09

HISTORY:
	New in 0.61

DESCRIPTION:
	This file does the work for the settings.xul Settings Dialog. It toggles settings in the Mozilla registry when buttons are pushed, displays About and Page Information, and does a bunch of Update work too.
	
*********/


var mozilePrefs="";
var mozileVersion = "";
var mozileStableXPIPath = "";
var mozileDevelopmentXPIPath = "";








function mozileOpenPage(node) {
	//alert(node.value);
	window.open(node.value);
}

function mozileGetSettings() {
	netscape.security.PrivilegeManager.enablePrivilege('UniversalXPConnect');
  mozilePrefs = Components.classes["@mozilla.org/preferences-service;1"].
                getService(Components.interfaces.nsIPrefBranch);

	//alert(mozilePrefs);
	//mp = mozilePrefs.getPrefType("browser.tabs.loadInBackground");
	//mozilePrefs.setBoolPref('accessibility.browsewithcaret', 'true');
	//alert(mp);
	
	mozileGetTab();
	
	mozileGetVersion();
	
	mozileGetAutohide();
	mozileGetCaret();
	mozileGetAccelerator();
	mozileGetAutoUpdate();
	mozileGetDebugLevel();
	
	mozileCheckForUpdates();
	mozileUpdatePageInfo();
}


function mozileGetTab() {
	var mode = opener.mozileGetMode();
	var tabs = document.getElementById("mozileTabs");
	switch(mode) {
		case "about":
			tabs.selectedIndex = 0;
			break;
		case "info":
			tabs.selectedIndex = 1;
			break;
		case "updates":
			tabs.selectedIndex = 2;
			break;
		default:
			tabs.selectedIndex = 3;
			break;
	}
}


function mozileGetVersion() {
	mozileVersion = opener.mozileGetVersion();

	var ver1 = document.getElementById("mozileVersionNumber");
	ver1.value = mozileVersion;
	
	var ver2 = document.getElementById("mozileCurrentVersion");
	ver2.value = mozileVersion;
}



function mozileGetAutohide() {
	var autohideCheckbox = document.getElementById("mozileAutohideCheckbox");
	autohideCheckbox.checked=mozilePrefs.getBoolPref("mozile.autohideBool");
}

function mozileSetAutohide(node) {
	netscape.security.PrivilegeManager.enablePrivilege('UniversalXPConnect');
	mozilePrefs.setBoolPref("mozile.autohideBool",!mozilePrefs.getBoolPref("mozile.autohideBool"));
}



function mozileGetCaret(node) {
	var caretCheckbox = document.getElementById("mozileCaretCheckbox");
	caretCheckbox.checked=mozilePrefs.getBoolPref("mozile.caretAlwaysOnBool");
}

function mozileSetCaret(node) {
	netscape.security.PrivilegeManager.enablePrivilege('UniversalXPConnect');
	mozilePrefs.setBoolPref("mozile.caretAlwaysOnBool",!mozilePrefs.getBoolPref("mozile.caretAlwaysOnBool"));
}



function mozileGetAccelerator(node) {
	var acceleratorCheckbox = document.getElementById("mozileAcceleratorCheckbox");
	acceleratorCheckbox.checked=mozilePrefs.getBoolPref("mozile.acceleratorBool");
}

function mozileSetAccelerator(node) {
	netscape.security.PrivilegeManager.enablePrivilege('UniversalXPConnect');
	mozilePrefs.setBoolPref("mozile.acceleratorBool",!mozilePrefs.getBoolPref("mozile.acceleratorBool"));
}



function mozileGetAutoUpdate() {
	var autoUpdateMenulist = document.getElementById("mozileAutoUpdateMenulist");
	autoUpdateMenulist.selectedIndex=mozilePrefs.getIntPref("mozile.autoUpdateInt");
}

function mozileSetAutoUpdate(node) {
	netscape.security.PrivilegeManager.enablePrivilege('UniversalXPConnect');
	switch(node.selectedIndex) {
		case 0:
			mozilePrefs.setIntPref("mozile.autoUpdateInt",0);
			break;
		case 1:
			mozilePrefs.setIntPref("mozile.autoUpdateInt",1);
			break;
		case 2:
			mozilePrefs.setIntPref("mozile.autoUpdateInt",2);
			break;
		default:
			alert("Error: "+node.selectedIndex);
	}
}




function mozileGetDebugLevel() {
	var debugLevelMenulist = document.getElementById("mozileDebugLevelMenulist");
	debugLevelMenulist.selectedIndex=mozilePrefs.getIntPref("mozile.debugLevelInt");
}

function mozileSetDebugLevel(node) {
	netscape.security.PrivilegeManager.enablePrivilege('UniversalXPConnect');
	switch(node.selectedIndex) {
		case 0:
			mozilePrefs.setIntPref("mozile.debugLevelInt",0);
			break;
		case 1:
			mozilePrefs.setIntPref("mozile.debugLevelInt",1);
			break;
		case 2:
			mozilePrefs.setIntPref("mozile.debugLevelInt",2);
			break;
		default:
			alert("Error: "+node.selectedIndex);
	}
}



function mozileCheckForUpdates() {

	var mozileUpdateURL = "http://mozile.mozdev.org/current.xml";
	var	mozileUpdateNS =	"http://archipelago.phrasewise.com/rsd";
	var	stableXPath	= "//stable";
	var	developmentXPath	= "//development";
	var xmlDoc;
	
		// handles the RSD file
	function callback (e) {
		// The RSD is loaded, let's	extract	data into a	config object
	
	//alert(printXML(xmlDoc));
		var	evaluator =	new	XPathEvaluator();
		
		try {
			var	stable = evaluator.evaluate(stableXPath, xmlDoc, null, 
						XPathResult.ANY_TYPE, null).iterateNext();
			
			var stableVersion = stable.getAttribute("version");
			mozileStableXPIPath = stable.getAttribute("path");
			
			document.getElementById("mozileStableVersion").value = stableVersion;
			document.getElementById("mozileStableReleased").value = 
					stable.getAttribute("released") + " ";
			document.getElementById("mozileStableType").value = 
					stable.getAttribute("type").toUpperCase() + " ";
			document.getElementById("mozileStableNotes").appendChild(document.createTextNode(stable.firstChild.nodeValue))			
			var	development = evaluator.evaluate(developmentXPath, xmlDoc, null, 
						XPathResult.ANY_TYPE, null).iterateNext();
			
			
			var developmentVersion = development.getAttribute("version");
			mozileDevelopmentXPIPath = development.getAttribute("path");
			
			document.getElementById("mozileDevelopmentVersion").value = developmentVersion;
			document.getElementById("mozileDevelopmentReleased").value = 
					development.getAttribute("released") + " ";
			document.getElementById("mozileDevelopmentType").value = 
					development.getAttribute("type").toUpperCase() + " ";
			document.getElementById("mozileDevelopmentNotes").appendChild(document.createTextNode(development.firstChild.nodeValue));
	
			var mozileInstallStableVersion = document.getElementById("mozileInstallStableVersion");
			if(stableVersion) {
				if(stableVersion > mozileVersion) {
					mozileInstallStableVersion.disabled=false;
					mozileInstallStableVersion.label="Upgrade to "+stableVersion;
				} else {
						if(stableVersion == mozileVersion) {
							mozileInstallStableVersion.disabled=false;
							mozileInstallStableVersion.label="Reinstall "+stableVersion;
						} else {
							mozileInstallStableVersion.disabled=false;
							mozileInstallStableVersion.label="Downgrade to "+stableVersion;
						}
				}
			}
			
					
			var mozileInstallDevelopmentVersion = document.getElementById("mozileInstallDevelopmentVersion");
			if(developmentVersion) {
				if(developmentVersion > mozileVersion) {
					mozileInstallDevelopmentVersion.disabled=false;
					mozileInstallDevelopmentVersion.label="Upgrade to "+developmentVersion;
				} else {
						if(developmentVersion == mozileVersion) {
							mozileInstallDevelopmentVersion.disabled=false;
							mozileInstallDevelopmentVersion.label="Reinstall "+developmentVersion;
						} else {
							mozileInstallDevelopmentVersion.disabled=false;
							mozileInstallDevelopmentVersion.label="Downgrade to "+developmentVersion;
						}
				}
			}
		
		} catch(e) {
			
		}
		
		window.status =	"Done";
	}
	
	
	if (mozileUpdateURL) {
		window.status =	"Checking for new versions at " + mozileUpdateURL;
	
		xmlDoc = document.implementation.createDocument(mozileUpdateNS, 
									"doc", null);
		// XXX:	If this	URL	is relative, it	might not work,	so detect this
		xmlDoc.load(mozileUpdateURL);
		xmlDoc.onload =	callback;
	}
		// default to the built in XHTML Editing Scheme.
	else {
		alert(mozileUpdateURL + " Didn't work");
	}

	return;
}

function mozileStableUpgrade() {
	window.open(mozileStableXPIPath);
}

function mozileDevelopmentUpgrade() {
	yes = confirm("The development version contains more bugs than the stable version. Are you sure you want to install the development version?");
	if(yes) {
		window.open(mozileDevelopmentXPIPath);
	}
}


function mozileUpdatePageInfo() {
	var mozileTarget = opener.mozileGetCurrentTarget();
	//var mozileTarget = window;
	
	if(mozileTarget=="") {
		document.getElementById("mozileLocation").value = "";
		document.getElementById("mozileConfigurationFile").value = "";
		document.getElementById("mozileSaveMethod").value =	"";
		document.getElementById("mozileEditOnly").value = "";
		document.getElementById("mozileMES").value = "";
		document.getElementById("mozileTagView").value = ""; 
		return;
	}
	
	
	document.getElementById("mozileLocation").value =	mozileTarget.document.location;
	
	try {
		document.getElementById("mozileConfigurationFile").value =	mozileTarget.document.MOZILE_RSD_CONFIG["rsdhref"];
	} catch(e) {
		document.getElementById("mozileConfigurationFile").value = "None";
	}
	
	try {
		document.getElementById("mozileSaveMethod").value =	mozileTarget.document.MOZILE_RSD_CONFIG["method"];
	} catch(e) {
		document.getElementById("mozileSaveMethod").value =	"Alert";
	}
	
	try {
		document.getElementById("mozileEditOnly").value = mozileTarget.document.MOZILE_RSD_CONFIG["editonly"];
	} catch(e) {
		document.getElementById("mozileEditOnly").value = "False";
	}
	
	try {
		document.getElementById("mozileMES").value =	mozileTarget.document.MOZILE_RSD_CONFIG["mes"];
	} catch(e) {
		document.getElementById("mozileMES").value = "XHTML";
		document.getElementById("mozileMES").setAttribute("class","");
	}
	
	try {
		document.getElementById("mozileTagView").value = mozileTarget.document.MOZILE_RSD_CONFIG["tagCSS"];
	} catch(e) {
		document.getElementById("mozileTagView").value = "XHTML";
		document.getElementById("mozileTagView").setAttribute("class","");
	}

}



